<template>
  <div>
    <v-row>
      <v-col cols="9">
        <v-card class="pa-5" flat>

          <h3 class="pb-5">User Details</h3>

          <v-text-field
            outlined
            label="First Name"
            v-model="first_name"
            class="required"
          >
          </v-text-field>

          <v-text-field
            outlined
            label="Last Name"
            v-model="last_name"
            class="required"
          >
          </v-text-field>

          <v-text-field
            outlined
            label="Email"
            v-model="email"
            class="required"
          >
          </v-text-field>

          <v-text-field
            disabled
            outlined
            label="Status"
            :value="status==1 ? 'Active' : 'Inactive'"
            class="required"
          >
          </v-text-field>

          <v-btn
            @click="$router.go(-1)"
            depressed
            color="primary"
          >
            Back
          </v-btn>

        </v-card>
      </v-col>

      <v-col>
        <v-card class="pa-5" flat>
          <div class="d-flex pb-5" style="justify-content:center;">
            <v-avatar size="350">
              <img
                :src="avatar"
              >
            </v-avatar>
          </div>
          
          <div class="d-flex" style="justify-content:center;">

            <update-user-dialog
              class="mx-2"
              @updateUser="updateUser"
            >
            </update-user-dialog>

            <activate-user-dialog
              class="mx-2"
              v-if="status==0"
              @activateUser="activateUser"
            >
            </activate-user-dialog>

            <deactivate-user-dialog
              class="mx-2"
              v-if="status==1"
              @deactivateUser="deactivateUser"
            >
            </deactivate-user-dialog>

            <delete-user-dialog
              class="mx-2"
              @deleteUser="deleteUser"
            >
            </delete-user-dialog>

          </div>
        </v-card>
      </v-col>
    </v-row>
  </div>
</template>

<script>
/* eslint-disable */

import axios from 'axios';
import DeactivateUserDialog from "@/components/deactivate-user-dialog.vue";
import ActivateUserDialog from "@/components/activate-user-dialog.vue";
import UpdateUserDialog from "@/components/update-user-dialog.vue";
import DeleteUserDialog from "@/components/delete-user-dialog.vue";


export default {
  name: "UserDetails",
  components: {DeactivateUserDialog, ActivateUserDialog, UpdateUserDialog, DeleteUserDialog},
  data() {
    return {
      userItem: null,
      email: null,
      first_name: null,
      last_name: null,
      avatar: null,
      id: null,
      status: 1,
    }
  },

  methods: {
    activateUser(){
      this.status = 1;
      this.$toasted.show("User has been activated successfully!")
    },

    deactivateUser(){
      this.status = 0;
      this.$toasted.show("User has been deactivated successfully!")
    },

    async updateUser(){
      await axios
        .put(`https://reqres.in/api/users/${this.$route.params.id}`, 
        { 
          first_name: this.first_name, 
          last_name: this.last_name,
          email: this.email,
        })
          .then(response => {
            this.$toasted.show("User's details has been updated successfully!")
            })
    },

    async deleteUser(){
      await axios
        .delete(`https://reqres.in/api/users/${this.$route.params.id}`)
          .then(response => {
            this.$toasted.show("User has been deleted successfully!")
            })
      this.$router.push({ name: "userListings"})
    },

    async loadItem(){
      await axios
        .get(`https://reqres.in/api/users/${this.$route.params.id}`)
        .then(response => {
          this.userItem = response.data.data;
          })
    },
  },

  async mounted(){
    (this.userItem = this.$route.params.user) || (await this.loadItem());

    Object.assign(this, this.userItem);
  },
};
</script>

